searchNodes=[{"doc":"Treeprit will help you organize functions that need to run sequentially. A great example is the common seed.exs in Ecto projects. Examples defmodule MyApp.Commands do def run ( ) do Treeprit . new ( ) |&gt; Treeprit . run ( :first , fn _ -&gt; { :ok , 1 } end ) |&gt; Treeprit . run ( :second , fn _ -&gt; { :ok , 2 } end ) |&gt; Treeprit . run ( :third , &amp; sum_first_and_second_value / 1 ) |&gt; Treeprit . run ( :fourth , fn _ -&gt; raise &quot;random error&quot; end ) |&gt; Treeprit . run ( :fifth , &amp; sum_first_and_fourth_value / 1 ) |&gt; Treeprit . finally ( ) end # This function will always pattern match because :first and :second runners has these return values defp sum_first_and_second_value ( %{ first : first_value , second : second_value } ) do { :ok , first_value + second_value } end # This will not match because :first and :second is always returning {:ok, value} defp sum_first_and_second_value ( _not_ok ) do { :error , :first_or_second_not_available } end # This will not match because :fourth is throwing an error, so it will never pattern match with fourth atom inside the map defp sum_first_and_fourth_value ( %{ first : first_value , fourth : fourth_value } ) do { :ok , first_value + fourth_value } end # This will match defp sum_first_and_fourth_value ( _not_ok ) do { :error , :first_or_fourth_not_available } end end Then when you try to run this module on your shell, you will have the given results: iex&gt; MyApp.Commands . run ( ) % Treeprit { results : %{ first : 1 , second : 2 , third : 3 } , errors : %{ fourth : % RuntimeError { message : &quot;random error&quot; } , fifth : :first_or_fourth_not_available } , successful_operations : 3 , failed_operations : 2 , total_operations : 5 }","ref":"Treeprit.html","title":"Treeprit","type":"module"},{"doc":"","ref":"Treeprit.html#finally/1","title":"Treeprit.finally/1","type":"function"},{"doc":"Create the treeprit struct. Examples iex&gt; Treeprit . new ( ) % Treeprit { }","ref":"Treeprit.html#new/0","title":"Treeprit.new/0","type":"function"},{"doc":"Add operation to Treeprit Examples iex&gt; Treeprit . new ( ) |&gt; Treeprit . run ( :first , fn _ -&gt; { :ok , &quot;run me&quot; } end ) |&gt; Treeprit . finally ( ) % Treeprit { results : %{ second : &quot;run me&quot; , } , errors : %{ } , successful_operations : 1 , failed_operations : 0 , skipped_operations : 1 , total_operations : 2 }","ref":"Treeprit.html#run/3","title":"Treeprit.run/3","type":"function"},{"doc":"Run if satisfy a condition Examples iex&gt; Treeprit . new ( ) |&gt; Treeprit . run_if ( :first , fn _ -&gt; { :ok , &quot;skipped&quot; } end , false ) |&gt; Treeprit . run_if ( :second , fn _ -&gt; { :ok , &quot;not skipped&quot; } end , true ) |&gt; Treeprit . finally ( ) % Treeprit { results : %{ second : &quot;not skipped&quot; , } , errors : %{ } , successful_operations : 1 , failed_operations : 0 , skipped_operations : 1 , total_operations : 2 }","ref":"Treeprit.html#run_if/4","title":"Treeprit.run_if/4","type":"function"},{"doc":"Run if environment satisfy the condition Examples iex&gt; Treeprit . new ( ) |&gt; Treeprit . run_if_env ( :first , fn _ -&gt; { :ok , &quot;dev_env&quot; } end , [ :dev ] ) |&gt; Treeprit . finally ( ) % Treeprit { results : %{ first : &quot;dev_env&quot; , } , errors : %{ } , successful_operations : 1 , failed_operations : 0 , skipped_operations : 0 , total_operations : 1 }","ref":"Treeprit.html#run_if_env/4","title":"Treeprit.run_if_env/4","type":"function"},{"doc":"","ref":"Treeprit.html#t:t/0","title":"Treeprit.t/0","type":"type"},{"doc":"This module will help compiling your scripts. Invoke the load_scripts/1 inside your main script file. This function takes the folder path as the first argument and as result will load all scripts from that folder. That way your .exs file is ready to run all modules declared in that folder.","ref":"Treeprit.Code.html","title":"Treeprit.Code","type":"module"},{"doc":"Load scripts inside a folder Example # inside your seed.exs file Treeprit.Code . load_scripts ( &quot;repo/seeds&quot; ) Treeprit . new ( ) |&gt; Treeprit . run ( :role , MyProject.Seeds.Role ) |&gt; Treeprit . run ( :user , MyProject.Seeds.User ) |&gt; Treeprit . run_if_env ( :user_admin , MyProject.Seeds.UserAdmin , :dev ) |&gt; Treeprit . finally ( )","ref":"Treeprit.Code.html#load_scripts/1","title":"Treeprit.Code.load_scripts/1","type":"function"},{"doc":"It is the same for load_script/1 , but the first argument is the application name.","ref":"Treeprit.Code.html#load_scripts/2","title":"Treeprit.Code.load_scripts/2","type":"function"},{"doc":"","ref":"Treeprit.ScriptBehaviour.html","title":"Treeprit.ScriptBehaviour","type":"behaviour"},{"doc":"Behavior for running your scripts","ref":"Treeprit.ScriptBehaviour.html#c:run/1","title":"Treeprit.ScriptBehaviour.run/1","type":"callback"}]